#ifndef _VxvContext_h
#define _VxvContext_h

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>

class xvContext: public xvCore
{
	public:
		xvContext();
		xvContext(String name, int argc, char **argv);
		~xvContext();

		void init(String name, int argc, char **argv);
		XtAppContext GetContext();
		void ServiceEvent(); 

		void RegisterWorkProc(XtWorkProc proc, XtPointer cdata);
		void UnregisterWorkProc();

		void AddAction(String acname, XtActionProc proc);
		
		XtActionHookId AddActionHook(XtActionHookProc proc, XtPointer clientdata);
		void RemoveActionHook();	

		void Error(String message);
		void ErrorMsg(String name, String etype, String eclass, String edefault, String *params,
			Cardinal *numpar);

	private:
		Display *ContextDisplay;
		XtAppContext ContextContext;
		XEvent ContextEvent;
		XtWorkProcId wproc;
		XtActionHookId waction;
		Boolean actionset;
		int flushcount;
};

#endif // _VxvContext_h
