#ifndef _VxvCore_h
#define _VxvCore_h

#include <X11/Xaw3d/Form.h>
#include <X11/Xaw3d/Label.h>
#include <X11/Xaw3d/Tree.h>

class xvCore
{
	public:
		~xvCore();

// ************************
//              xvCore Resource methods
//************************
		
		virtual void Hide();
		virtual void Show();
		virtual void Map();
		virtual void Unmap();

		virtual void SetAccelerators(XtAccelerators atable);
		virtual void SetAncestorSensitive(Boolean sense);
		virtual void SetBackground(Pixel b);
		virtual void SetBackground(String colour);
		virtual void SetBackgroundPixmap(Pixmap p);
		virtual void SetBorderColor(Pixel b);
		virtual void SetBorderColor(String colour);
		virtual void SetBorderPixmap(Pixmap p);
		virtual void SetBorderWidth(Dimension b);
		virtual Dimension GetBorderWidth();
		virtual void SetColormap(Colormap c);
		virtual void SetDepth(int d);
		virtual int GetDepth();
		virtual void SetDestroyCallback(XtCallbackProc d);
		virtual void SetHeight(Dimension h);
		virtual Dimension GetHeight();
		virtual void SetMappedWhenManaged(Boolean m);
		virtual void SetSensitive(Boolean s);
		virtual void SetTranslations(XtTranslations trans);
		virtual void OverrideTranslations(XtTranslations trans);
		virtual void AugmentTranslations(XtTranslations trans);
		virtual void SetWidth(Dimension xw);
		virtual Dimension GetWidth();
		virtual void SetX(Position x);
		virtual Position GetX();
		virtual void SetY(Position y);
		virtual Position GetY();
		virtual void SetXY(Position x, Position y);
		virtual void GetXY(Position *x, Position *y);
		virtual void SetGeometry(Position x, Position y, Dimension wid, Dimension h);
		virtual void GetGeometry(Position*x, Position *y, Dimension *wid, Dimension *h);
		virtual void SetSize(Dimension wid, Dimension h);
		virtual void GetSize(Dimension *wid, Dimension *h);

		virtual void SetResource(String rname, XtArgVal val);
		virtual void GetResource(String rname, XtArgVal *val);

		virtual void AddEvent(EventMask eventmask, XtEventHandler hander, XtPointer cdata);
		virtual void RemoveEvent(EventMask eventmask, XtEventHandler hander, XtPointer cdata);
		virtual void AddGrab(Boolean exclusive, Boolean sprung);
		virtual void RemoveGrab();


// ********************************
//		Widget-Specific Resources
// ********************************

		virtual void SetLabel(String lab);
		virtual void SetFont(XFontStruct *xfs);
		virtual void SetForeground(Pixel fg);
		virtual void SetForeground(String colour);
		virtual void SetFontSet(XFontSet xfnt);
		virtual void SetJustify(XtJustify xj);
		virtual void SetCallback(XtCallbackProc callback);
		virtual void SetInternalHeight(Dimension ih);
		virtual Dimension GetInternalHeight();
		virtual void SetInternalWidth(Dimension iw);
		virtual Dimension GetInternalWidth();
		virtual void SetCursorName(String cname);
		virtual void SetCursor(Cursor curs);
	
// ********************************
//		Constraint Resources
// ********************************

		virtual void SetIcon(Pixmap ico);
		virtual void SetHSpace(Dimension hs);
		virtual void SetVSpace(Dimension vs);
		virtual void SetBottomEdge(XawEdgeType bedge);
		virtual void SetLeftEdge(XawEdgeType ledge);
		virtual void SetRightEdge(XawEdgeType redge);
		virtual void SetTopEdge(XawEdgeType tedge);
		virtual void SetRelHorizontal(xvCore & wg);
		virtual void SetRelVertical(xvCore & wg);
		virtual void SetRelative(xvCore & hg, xvCore & vg);
		virtual void SetResizable(Boolean srz);
		virtual void SetVertDistance(int vd);
		virtual int GetVertDistance();
		virtual void SetHorizDistance(int hd);
		virtual int GetHorizDistance();
		virtual void SetDistance(int hd, int vd);
		virtual void GetDistance(int *hd, int *vd);
		virtual void SetDefaultDistance(int dd);
		virtual void SetTreeGC(GC ngc);
		virtual void SetTreeParent(Widget parent);
		virtual void SetTreeParent(xvCore & parent);
		virtual void SetFixedPosition(Boolean fix);

// ***********************
//              ThreeD Methods
// ***********************

		virtual void SetShadowWidth(Dimension sw);
		virtual void SetTopShadowPixel(Pixel tsp);
		virtual void SetTopShadowPixel(String colour);
		virtual void SetBottomShadowPixel(Pixel bsp);
		virtual void SetBottomShadowPixel(String colour);
		virtual void SetTopShadowContrast(int tsc);
		virtual void SetBottomShadowContrast(int bsc);
		virtual void SetUserData(XtPointer ud);
		virtual void SetBeNiceToColormap(Boolean bntc);

		virtual Pixel stringToPixel(String colname);

// *********************
//              Other methods
// *********************

		virtual Pixmap SetBitmapInfo(char *bits, unsigned int sw, unsigned int sh, 
			String resource=NULL);	
		virtual Pixmap SetBitmapInfo(unsigned char *bits, unsigned int sw, unsigned int sh, 
			String resource=NULL);	
		virtual Pixmap SetPixmapInfo(char **bits, String resource=NULL);

		virtual void SetBitmap(Pixmap pix);
		virtual Widget ID();

	protected:
		Widget w;
		Pixmap icon, iconmask;
};

#endif // _VxvCore_h