#ifndef _VxvEditField_h
#define _VxvEditField_h


class xvEditField: public xvCore
{
	public:
		xvEditField();
		xvEditField(String name, xvCore & parent, XawTextEditType mode, 
			Dimension sizeH, Dimension sizeL,
			XawAsciiType etype=XawAsciiString, String datasrc=NULL, 
			Boolean resizable=TRUE, XtCallbackProc callback=NULL, 
			String clientdata=NULL);
		~xvEditField();

		void init(String name, xvCore & parent, XawTextEditType mode, 
			Dimension sizeH, Dimension sizeL,
			XawAsciiType etype=XawAsciiString, String datasrc=NULL,
			Boolean resizable=TRUE, XtCallbackProc callback=NULL,
			String clientdata=NULL);

		void init(String name, Widget parent, XawTextEditType mode, 
			Dimension sizeH, Dimension sizeL,
			XawAsciiType etype=XawAsciiString, String datasrc=NULL,			
			Boolean resizable=TRUE, XtCallbackProc callback=NULL,
			String clientdata=NULL);

		void ChangeFont(String fontname);
		void SetSelection(XawTextPosition left, XawTextPosition right);
		void UnsetSelection();
		void Position(XawTextPosition *tbegin, XawTextPosition *tend);
		int Replace(XawTextPosition start, XawTextPosition end, XawTextBlock *text);
		XawTextPosition Search(XawTextScanDirection dir, XawTextBlock *text);
		void Invalidate(XawTextPosition from, XawTextPosition to);
		void EnableRedisplay();
		void DisableRedisplay();
		void TextDisplay();
		XawTextPosition TopPosition();
		void SelectionArray(XawTextSelectType *sarray);
		void InsertionPoint(XawTextPosition pos);
		XawTextPosition GetInsertionPoint();
		void SetSource(Widget source, XawTextPosition pos);
		Widget GetSource();
		void DisplayCaret(Boolean visable);
		char *ReturnString(char *ptr);

		Boolean Save();
		Boolean SaveAs(String name);
		Boolean SourceChanged();

		XawTextPosition SourceRead(XawTextPosition pos, XawTextBlock *block,
			int length);
		XawTextPosition SourceReplace(XawTextPosition start, XawTextPosition end, 
			XawTextBlock *text);
		XawTextPosition SourceScan(XawTextPosition pos, XawTextScanType stype,
			XawTextScanDirection dir, int count, Boolean include);
		XawTextPosition SourceSearch(XawTextPosition pos, 
			XawTextScanDirection dir, XawTextBlock *block);

		void Echo(Boolean echo);
		void Wrap(XawTextWrapMode wrap);
		void Callback(XtCallbackProc callback, String clientdata);
		void AutoWrap(Boolean autowrap);
		void DisplayChars(Boolean ctrl);
		void ResizeMode(XawTextResizeMode rmode);
		void HorizontalScrollBar(XawTextScrollMode hsc);
		void VerticalScrollBar(XawTextScrollMode hsc);
		void SetString(String str);

	private:
		xvFont bfont;
		Widget Source;						
		Widget Sink;
		Boolean alloc;
};

#endif _VxvEditField_h
