#ifndef _VxvFileDialog_h
#define _VxvFileDialog_h

class xvFileDialog:public xvCore
{
	public:
		xvFileDialog();
		xvFileDialog(String name, xvCore & parent, String pathname,
				XtCallbackProc filelist_callback, XtCallbackProc dirlist_callback,
				XtCallbackProc ok_callback, XtCallbackProc cancel_callback,
				XtCallbackProc err_callback, XtActionProc edit_callback,
				xvContext & appcontext, String mask, Boolean maskActive=FALSE,
				Boolean allowDirchange=TRUE);
		~xvFileDialog();

		void init(String name, xvCore & parent, String pathname,
				XtCallbackProc filelist_callback, XtCallbackProc dirlist_callback,
				XtCallbackProc ok_callback, XtCallbackProc cancel_callback,
				XtCallbackProc err_callback, XtActionProc edit_callback,
				xvContext & appcontext, String mask, Boolean maskActive=FALSE,
				Boolean allowDirchange=TRUE);

		void ClearError(XtPointer calldata);
		void NewPath(String pathname);
		void EditEntry();
		
		String File(XtPointer call);
		String Directory(XtPointer call);

		String SelectedFile(String returnpathname);
		void UpdateFileBox(String newstr);

	private:
		
		void UpdateFileList();
		void UpdateDirList();
		int GetNumEntries(String pathname);
		int ParseFileTree(String pathname, int entries);
		void ToggleClick(Widget wd, XtPointer cl, XtPointer ca);

		xvForm tform;
		xvLabel tflabel, tdlabel, tfblabel, pathlabel;
		xvView tfbview, tdview;
		xvList tdlist, tfblist;
		xvButton ok, cancel;
		xvLabel rspacer, bspacer;
		xvEditField tfedit;
		xvToggle ttoggle;
		xvMsgBox tmsg;

		char currentpath[180];
		char currentfile[40];
		char currentnum[30];
		char filemask[80];
		char* *filelist;
		char* *dirlist;
		struct dirent *superlist;
		struct stat *statlist;

		int numfiles, numdirs, numentries;
		Boolean usemask;
		int allocflag, hiddenflag;
};

#endif // _VxvFileDialog_h
