#ifndef _VxvFileList_h
#define _VxvFileList_h

#define XVFILELIST	0
#define XVDIRLIST	1
#define XVALLLIST	2

#define XVRELATIVEPATH	0
#define XVABSOLUTEPATH	1

class xvFileList: public xvView, public xvList
{
	public:
		xvFileList();
		xvFileList(String name, xvCore & parent, String path, int mode, Boolean hidden,
				XtCallbackProc filelist_callback, Boolean manage=TRUE);
		~xvFileList();

		void init(String name, xvCore & parent, String path, int mode, Boolean hidden,
				XtCallbackProc filelist_callback, Boolean manage=TRUE);

		int SetNewPath(String pathname, int mode, Boolean hidden);

		void GetResource(String resname, XtArgVal *val);
		void SetResource(String resname, XtArgVal val);
		void SetFixedPosition(Boolean val);

		char *GetSelectedItem(XtPointer call, int pathmode);
		char *Directory(String path);

		void SetForeground(String name);
		void SetForeground(Pixel fg);
		void SetBackground(String name);
		void SetBackground(Pixel bg);

		void Map();
		void Unmap();
		void SetSensitive(Boolean sense);
		void SetMappedWhenManaged(Boolean man);
		
		void AddEvent(EventMask eventmask, XtEventHandler handler, XtPointer cdata);
		void RemoveEvent(EventMask eventmask, XtEventHandler handler, XtPointer cdata);

	private:

		int NewPath(String pathname, int mode, Boolean hidden);
		int GetNumEntries(String pathname);
		int ParseFileTree(String pathname);
		
		char currentpath[180];
		char workingbuffer[180];
		char dirbuffer[180];

		char* *filelist;
		struct dirent *superlist;

		int numfiles, numentries, datamode;
		Boolean allocflag, hiddenflag;

};

#endif // _VxvFileList_h
