#ifndef _VxvGC_h
#define _VxvGC_h

#define XVDEFAULTGC		1
#define XVAUXGC1			2
#define XVAUXGC2			3

class xvGC: public xvCore
{
	public:
		xvGC();
		xvGC(xvCore & object);
		~xvGC();

		// ** init Methods		
		void init(xvCore & object);
		void init(Widget gcw);

		// ** GC Methods
		void GCFlush();
		void GCSetState(Pixel foreground, Pixel background, int func, Pixel plane_mask);
		void GCSetForeground(Pixel foreground);
		void GCSetBackground(Pixel background);
		void GCSetFunction(int func);
		void GCSetPlaneMask(Pixel plane_mask);
		void GCSetLineAttributes(unsigned int line_width, int line_style, 
					int cap_style, int join_style);
		void GCSetDashes(int dash_offset, char dash_list[], int num_elements);
		void GCSetFillStyle(int fill_style);
		void GCSetFillRule(int fill_rule);
		void GCSetTile(Pixmap tile);
		void GCSetStipple(Pixmap stipple);
		void GCSetTSOrigin(int tso_x, int tso_y);
		void GCSetFont(Font font);
		void GCSetClipOrigin(int clip_ox, int clip_oy);
		void GCSetClipMask(Pixmap pix);
		void GCSetClipRectangles(int clip_ox, int clip_oy, XRectangle rect[], 
					int numrec, int xorder);
		void GCSetArcMode(int arc_mode);
		void GCSetSubMode(int sub_mode);
		void GCSetGraphicsExposures(Boolean gexpose);
		
		Status GCQueryBestSize(int vclass, unsigned int width, unsigned int height, 
					unsigned int *width_ret, unsigned int *height_ret);
		Status GCQueryBestTile(unsigned int width, unsigned int height, 
					unsigned int *width_ret, unsigned int *height_ret);
		Status GCQueryBestStipple(unsigned int width, unsigned int height, 
					unsigned int *width_ret, unsigned int *height_ret);

		Window WinID();
		GC GCGetGC();
		void GCSwitchGC(int which);
		void GCRegion(xvRegion & r);
		void GCPointerXY(int *x, int *y, int *rx, int *ry, unsigned int *btn);
		void GCWin2Root(int x, int y, int *tx, int *ty);
		void GCRoot2Win(int x, int y, int *tx, int *ty);

	protected:
		Widget xvwidget;
		GC xvcontext;
		GC maincontext, backupcontext1, backupcontext2;
		Display *xvdisplay;
		Screen *xvscreen;
		Window xvwindow;
		
	private:
		Boolean alloc;
};

#endif // _VxvGC_h