#ifndef _VxvGraphic_h
#define _VxvGraphic_h

class xvGraphic: public xvGC
{
	public:
		xvGraphic();
		~xvGraphic();

		void init(xvCore & object);
		void init(Widget wid);

		void GClearArea(int x, int y, unsigned int width, unsigned int height, Boolean exposures);
		void GClearWindow();
		void GCopyArea(xvGC & dest, int sx, int sy, unsigned int width, unsigned int height,
					int dx, int dy);
		void GCopyPlane(xvGC & dest, int sx, int sy, unsigned int width, unsigned int height,
					int dx, int dy, unsigned long plane);
		void GDrawPoint(int x, int y);
		void GDrawPoints(XPoint *points, int npoints, int mode);
		void GDrawLine(int x1, int y1, int x2, int y2);
		void GDrawLines(XPoint *points, int npoints, int mode);
		void GDrawSegments(XSegment *segments, int nseg);		
		void GDrawRectangle(int x, int y, unsigned int width, unsigned int height);
		void GDrawRectangles(XRectangle rectangles[], int nrect);
		void GDrawArc(int x, int y, unsigned int width, unsigned int height,
					int angle1, int angle2);
		void GDrawArcs(XArc *arcs, int narcs);
		void GFillRectangle(int x, int y, unsigned int width, unsigned int height);
		void GFillRectangles(XRectangle *rectangles, int nrect);
		void GFillPolygon(XPoint *points, int npoints, int shape, int mode);
		void GFillArc(int x, int y, unsigned int width, unsigned int height, 
					int angle1, int angle2);
		void GFillArcs(XArc *arcs, int narcs);

		void GPrint(int x, int y, String message);
		void GPrintImage(int x, int y, String message);				

		XImage *GGetImage(int x, int y, unsigned int width, unsigned int height,
					unsigned long plane_mask, int format);

		XImage *GGetSubImage(int x, int y, unsigned int width, unsigned int height,
					unsigned long plane_mask, int format, 
					int dx, int dy, XImage *image=NULL);

		void GPutImage(int sx, int sy, int dx, int sy, unsigned int width, unsigned int height,
					XImage *image=NULL);

	private:
		XImage *gimage;
};

#endif // _VxvGraphic_h