#ifndef _VxvSizer_h
#define _VxvSizer_h

#define MINWIDTH 26;
#define MINHEIGHT 17;

#define XVSIZEMOVE 0
#define XVSIZEONLY 1
#define XVMOVEONLY 2

class xvSizer: public xvCore
{

	public:
		xvSizer();
		xvSizer(xvWindow & wparent, int x, int y, int wid, int hgt, int mode, int gripsize,
				XtCallbackProc size_callback, XtCallbackProc move_callback,
				XtEventHandler motion_callback, XtEventHandler stop_callback);
		~xvSizer();

		void init(xvWindow & wparent, int x, int y, int wid, int hgt, int mode, int gripsize,
				XtCallbackProc size_callback, XtCallbackProc move_callback,
				XtEventHandler motion_callback, XtEventHandler stop_callback);

		void SizerShow(xvWindow & wparent);
		void SizerHide(xvWindow & wparent);
		void SizerMove(xvWindow & wparent, XtPointer client);
		void SizerSize(xvWindow & wparent, XtPointer client);
		void SizerMotion(xvWindow & wparent);
		void SizerStop(xvWindow & wparent);
		void SizerUnhook(xvWindow & wparent);
		void SizerInfo(int *x, int *y, int *wid, int *hgt);
		void SizerWarp(xvWindow & wparent, int wpx, int wpy, int wid, int hgt);
		Boolean SizerIsVisible();

	private:
	
		xvGrip tl, tm, tr;
		xvGrip bl, bm, br;
		void setColours(xvWindow & wparent);
		XtCallbackProc size_call, move_call;
		XtEventHandler motion_call, stop_call;

		int wide, high;
		int px, py;
		int lx, ly;
		int pivotpoint;
		int sizermode;
		int gsize, minheight, minwidth; 
		int maxx, maxy;

		Boolean Sizing, Moving, Visible;
};


#endif // _VxvSizer_h
